<?php
/*
Plugin Name: Video Onclick
Plugin URI: http://tigors.net/en/en-video-onclick/
Description: Inserts video code only when user clicks on Play picture. Reduces load time on pages with many videos.  
Version: 0.4.1
Author: TIgor
Author URI: http://tigors.net
License: GPL2
*/


/*  Copyright 2011 Tesliuk Igor  (email : tigor@tigor.org.ua)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
function video_onclick_jscript()
	{
	$options = get_option('video_onclick_options');
	?>
	<script type="text/javascript" src="<?php echo plugins_url() ?>/video-onclick/video-onclick.js">
	
	</script>
	<script type="text/javascript">
	function videoinfo() {
		return '<?php
			echo str_replace(array("\n","\r\n"), '',$options['info']);
		?>';
	}
	
	function videoclosetext() {
	return '<?php
		if ($options['info']) {
			echo str_replace(array("\n","\r\n"), '',$options['close']);
		} else {
			echo 'Close(x)';
		}
	
	?>';
	}
	</script>
	<?php
	}

function youtube_shortcode($atts,$content)
	{
		
	$ret = '<div width="640" height="390" id="'.$content.'"><img src="'.video_onclick_youtube_thumb($content).'" onClick="voutub('."'".$content."'".')"></div>';
	
	return $ret;
	}
	
function vimeo_shortcode($atts,$content)
	{
		
	$ret = '<div width="640" height="390" id="vimeo'.$content.'"><img src="'.plugins_url().'/video-onclick/play_vimeo.jpg" onClick="vovimeo('."'".$content."'".')"></div>';
	
	return $ret;
	}
	
function video_onclick_java($plugin_array) {
   $plugin_array['youtube'] = plugins_url().'/video-onclick/youtube-button.js';
   $plugin_array['vimeo'] = plugins_url().'/video-onclick/vimeo-button.js';
   return $plugin_array;
	} 


function video_onclick_button($buttons) {
    array_push($buttons, 'youtube');
	array_push($buttons, 'vimeo');
    return $buttons;
     }

function video_onclick_init()
	{
	add_shortcode( 'youtube', 'youtube_shortcode' );
	add_shortcode( 'vimeo', 'vimeo_shortcode' );
	add_action("wp_print_scripts", "video_onclick_jscript");
	add_filter('mce_buttons', 'video_onclick_button', 0);
	add_filter('mce_external_plugins', 'video_onclick_java');
	}


function options_video_onclick() {
	?>
	<form method="post" action="options.php"> 
	<h2>Video Onclick Settings</h2>
	<hr />
	<?php 
	settings_fields('video_onclick_group');
	$options = get_option('video_onclick_options');
	
	?>
	<h3>Info DIV</h3>
	This text will be printed with video.<br />
	<textarea name="video_onclick_options[info]" cols="120" rows="10"><?php echo $options['info']; ?></textarea>
	
	<h3>Close DIV</h3>
	This text will be shown as close button.
	<input  type="text" value="<?php echo $options['close']; ?>" name="video_onclick_options[close]" />
	<?php
	
	?> <p class="submit">
    <input type="submit" class="button-primary" value="Save Changes" />
    </p>
	</form> 
	<?php 

	
	
}

function video_onclick_youtube_thumb($videoid) {
	$return = false;
	$temp['width'] = 0;
	$temp['url'] = '';
	$cache = get_option('video_onclick_cache');

	if ((time() - 60*60*24) > $cache[$videoid]['time'])
	{
		// Cache is old or does not exist
		$ch = curl_init();
		$url = 'http://gdata.youtube.com/feeds/api/videos/'. $videoid;	

		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 2);

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	
		$respond = curl_exec($ch);
		
		if (200 == (int)curl_getinfo($ch, CURLINFO_HTTP_CODE))
		{

		
			$sxml = new SimpleXMLElement($respond);

			$media = $sxml->children('http://search.yahoo.com/mrss/');
		

		
			$group = $media->group;
		

			foreach( $group->thumbnail as $thumb) {

				if ($temp['width'] < $thumb->attributes()->width) {
				$temp['url'] =  (string)$thumb->attributes()->url;
				$temp['width'] = $thumb->attributes()->width;
				}

			}
			if ('' == $temp['url'])
			{

				$return = plugins_url().'/video-onclick/play_youtube.jpg';
			} else {

				$cache[$videoid]['time'] = time();
				$cache[$videoid]['url'] = $temp['url'];

			
				update_option('video_onclick_cache', $cache);
			
				$return = $temp['url'];
			}
		} else {
			$return = plugins_url().'/video-onclick/play_youtube.jpg';
		}
		
	} else {
		// Cache is OK 
		
		$return = $cache[$videoid]['url'];
	}
	

	return $return;
}

function register_video_onclick_settings() {
	register_setting('video_onclick_group','video_onclick_options');
}

add_action('admin_menu',"video_onclick_menu");
	
function video_onclick_menu() {
	add_options_page('Video Onclick', 'Video Onclick', 'manage_options', 'video_onclick', 'options_video_onclick');
	add_action( 'admin_init', 'register_video_onclick_settings' );
}
	
add_action("plugins_loaded", "video_onclick_init");





	 

?>